package com.wikihouse.wildcats0201.jdbcchart;

import java.io.InvalidObjectException;
import java.sql.Connection;
import java.sql.SQLException;

import org.jfree.data.DomainOrder;
import org.jfree.data.Range;
import org.jfree.data.RangeInfo;
import org.jfree.data.general.DatasetChangeListener;
import org.jfree.data.general.DatasetGroup;
import org.jfree.data.general.SeriesChangeEvent;
import org.jfree.data.xy.TableXYDataset;
import org.jfree.data.xy.XYDataset;

/**
 * <B>JDBCXYDatasetEnhance </B>. JDBCXYDataset̃C^[tFCXłB
 * 
 * @see org.jfree.data.jdbc.JDBCXYDataset
 * @author $Author: wildcats $
 * @version $Revision: 5 $
 */
public interface JDBCXYDatasetEnhance extends XYDataset, TableXYDataset,
        RangeInfo {

    void addChangeListener(DatasetChangeListener listener);

    void close();

    boolean equals(Object arg0);

    void executeQuery(String query) throws SQLException;

    void executeQuery(Connection con, String query) throws SQLException;

    DomainOrder getDomainOrder();

    DatasetGroup getGroup();

    int getItemCount();

    int getItemCount(int series);

    int getLegendItemCount();

    String[] getLegendItemLabels();

    void setLegendItemLabels(String[] itemLabels);

    Range getRangeBounds(boolean includeInterval);

    double getRangeLowerBound(boolean includeInterval);

    double getRangeUpperBound(boolean includeInterval);

    int getSeriesCount();

    String getSeriesName(int series);

    Number getX(int series, int item);

    double getXValue(int series, int item);

    Number getY(int series, int item);

    double getYValue(int series, int item);

    int hashCode();

    boolean isTimeSeries();

    void removeChangeListener(DatasetChangeListener listener);

    void seriesChanged(SeriesChangeEvent event);

    void setGroup(DatasetGroup group);

    void setTimeSeries(boolean timeSeries);

    String toString();

    void validateObject() throws InvalidObjectException;
}