package com.wikihouse.wildcats0201.jdbcchart;

import java.sql.Connection;

import org.jfree.chart.ChartFactory;
import org.jfree.chart.JFreeChart;
import org.jfree.data.general.Dataset;
import org.jfree.data.xy.XYDataset;

import com.wikihouse.wildcats0201.jdbcchart.dto.ChartDTO;

/**
 * <B>LineChartFactory </B>. LineChartFactoryłB
 * 
 * @see LineChart
 * @author $Author: wildcats $
 * @version $Revision: 5 $
 */
public class LineChartFactory {

    private LineChartFactory() {
    }

    /**
     * LineChartԋp܂B ̎łXyLineChart𐶐ԋp܂B
     * 
     * @return LineChart̃CX^X
     */
    public static LineChart create() {
        return new XYLineChart();
    }

    /**
     * <B>XYLineChart </B>. LineChart̎łB
     * 
     * @author $Author$
     * @version $Revision: 5 $
     */
    private static class XYLineChart implements LineChart {

        /**
         * @see com.wikihouse.wildcats0201.jdbcchart.LineChart#getDataSet(java.sql.Connection,
         *      java.lang.String)
         */
        public Dataset getDataSet(Connection conn, String sql) {
            return DatasetFactory
                    .create(
                            "com.wikihouse.wildcats0201.jdbcchart.impl.JDBCXYDatasetEnhanceImpl",
                            conn, sql);
        }

        /**
         * @see com.wikihouse.wildcats0201.jdbcchart.LineChart#getJFreeChart(com.wikihouse.wildcats0201.jdbcchart.dto.ChartDTO)
         */
        public JFreeChart getJFreeChart(ChartDTO data) {
            return ChartFactory.createXYLineChart(data.getTitle(), data
                    .getXAxisLabel(), data.getYAxisLabel(), (XYDataset) data
                    .getDataset(), data.getOrientation(), data.isLegend(), data
                    .isTooltips(), data.isUrls());
        }

    }

}
