package com.wikihouse.wildcats0201.jdbcchart.ant;

import java.io.File;
import java.text.MessageFormat;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.DirectoryScanner;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.Task;
import org.apache.tools.ant.loader.AntClassLoader2;
import org.apache.tools.ant.types.FileSet;
import org.apache.tools.ant.types.Path;
import org.apache.tools.ant.types.Reference;

import com.wikihouse.wildcats0201.jdbcchart.XYChartByJDBC;

/**
 * <B>XyLineChartTask </B>. Chart̍쐬sAnt^XNłB
 * 
 * @author $Author: wildcats $
 * @version $Revision: 5 $
 */
public class XyLineChartTask extends Task {

    private List fileList = new LinkedList();

    private Path classpath;

    private String driver;

    private String user;

    private String password;

    private String url;

    /**
     * FileSet𐶐ԋp܂B
     * 
     * @return FileSet
     */
    public FileSet createFileSet() {
        FileSet fs = new FileSet();
        fileList.add(fs);
        return fs;
    }

    private String[] getUrlPaths() {
        List list = new LinkedList();

        for (Iterator it = this.fileList.iterator(); it.hasNext();) {
            FileSet fileset = (FileSet) it.next();
            DirectoryScanner scanner = fileset
                    .getDirectoryScanner(getProject());
            String[] files = scanner.getIncludedFiles();
            StringBuffer sb = new StringBuffer();
            for (int i = 0; i < files.length; i++) {
                sb.append(scanner.getBasedir().getAbsolutePath());
                sb.append(File.separatorChar);
                sb.append(files[i]);
                list.add(sb.toString());
                log(MessageFormat.format("target file [{0}]", new Object[] { sb
                        .toString() }));
                sb.delete(0, sb.length());
            }
        }
        return (String[]) list.toArray(new String[list.size()]);
    }

    /**
     * NXpXReferenceݒ肵܂B
     * 
     * @param r
     *            Reference
     */
    public void setClasspathRef(Reference r) {
        createClasspath().setRefid(r);
    }

    /**
     * NXpXݒ肵܂B
     * 
     * @param classpath
     *            NXpX
     */
    public void setClasspath(Path classpath) {
        if (this.classpath == null) {
            this.classpath = classpath;
        } else {
            this.classpath.append(classpath);
        }
    }

    /**
     * NXpXԋp܂B
     * 
     * @return NXpX
     */
    public Path createClasspath() {
        if (this.classpath == null) {
            this.classpath = new Path(getProject());
        }
        return this.classpath;
    }

    /**
     * JDBChCoݒ肵܂B
     * 
     * @param driver
     *            JDBChCo
     * @todo Validation
     */
    public void setDriver(String driver) {
        this.driver = driver;
    }

    /**
     * JDBCڑURLݒ肵܂B
     * 
     * @param url
     *            JDBCڑURL
     * @todo Validation
     */
    public void setUrl(String url) {
        this.url = url;
    }

    /**
     * f[^x[XpX[hݒ肵܂B
     * 
     * @param password
     *            pX[h
     */
    public void setPassword(String password) {
        this.password = password;
    }

    /**
     * f[^x[X[Uݒ肵܂B
     * 
     * @param user
     *            [U
     */
    public void setUser(String user) {
        this.user = user;
    }

    /**
     * @see org.apache.tools.ant.Task#execute()
     */
    public void execute() throws BuildException {
        AntClassLoader2 loader = (AntClassLoader2) this.getClass()
                .getClassLoader();
        loader.setClassPath(this.classpath);

        log(loader.getClasspath(), Project.MSG_INFO);

        String[] files = this.getUrlPaths();
        for (int i = 0; i < files.length; i++) {
            XYChartByJDBC xyChartByJDBC = new XYChartByJDBC();
            xyChartByJDBC.execute(files[i], this.driver, this.url, this.user,
                    this.password);
        }

    }

}
