package com.wikihouse.wildcats0201.jdbcchart.dom4j;

import java.util.Iterator;

import org.dom4j.Document;
import org.dom4j.DocumentException;
import org.dom4j.Element;

import com.wikihouse.wildcats0201.jdbcchart.dto.ChartFile;
import com.wikihouse.wildcats0201.jdbcchart.dto.ChartXMLDTO;
import com.wikihouse.wildcats0201.jdbcchart.dto.Item;
import com.wikihouse.wildcats0201.jdbcchart.dto.Label;
import com.wikihouse.wildcats0201.jdbcchart.dto.SQL;

/**
 * <B>XMLParserFactory </B>. XMLParserFactoryłB
 * 
 * @author $Author: wildcats $
 * @version $Revision: 5 $
 */
public final class XMLParserFactory {

    private XMLParserFactory() {
    }

    /**
     * .
     * 
     * @return XMLParser
     */
    public static XMLParser create() {
        return new XMLParseImpl();
    }

    /**
     * <B>XMLParseImpl </B>. XMLParser̎łB
     * 
     * @todo Validation
     * @author $Author: wildcats $
     * @version $Revision: 5 $
     */
    private static class XMLParseImpl implements XMLParser {

        /**
         * @see com.wikihouse.wildcats0201.jdbcchart.dom4j.XMLParser#read(java.lang.String)
         */
        public ChartXMLDTO read(String fileName) {
            SAXReaderWrapper parser = SAXReaderWrapperFactory.create();
            Document document = null;
            try {
                document = parser.parse(fileName);
            } catch (DocumentException e) {
                throw new RuntimeException(e);
            }
            Element root = document.getRootElement();

            Element labelElement = root.element("label");

            ChartXMLDTO data = new ChartXMLDTO();

            Label label = new Label(labelElement.attributeValue("title"),
                    labelElement.attributeValue("xLabel"), labelElement
                            .attributeValue("yLabel"));

            data.setLabel(label);

            Element seriesElement = root.element("series");
            for (Iterator i = seriesElement.elementIterator("item"); i
                    .hasNext();) {
                Element itemElement = (Element) i.next();
                Item item = new Item(itemElement.attributeValue("name"));
                data.addSeries(item);
            }

            Element fileElement = root.element("file");
            ChartFile file = new ChartFile(fileElement.attributeValue("path"),
                    fileElement.attributeValue("name"), fileElement
                            .attributeValue("type"), getIntValue(fileElement
                            .attributeValue("width")), getIntValue(fileElement
                            .attributeValue("height")));

            data.setFile(file);

            Element sqlElement = root.element("sql");
            SQL sql = new SQL(sqlElement.getText());
            data.setSQL(sql);
            return data;
        }

        private int getIntValue(String string) {
            return Integer.parseInt(string);
        }

    }

}
