package com.wikihouse.wildcats0201.jdbcchart.dto;

import org.jfree.chart.JFreeChart;

import com.wikihouse.wildcats0201.jdbcchart.fsutil.Directory;
import com.wikihouse.wildcats0201.jdbcchart.fsutil.DirectoryFactory;

/**
 * <B>ChartFile </B>.
 * 
 * @author $Author: wildcats $
 * @version $Revision: 5 $
 */
public class ChartFile {

    private final String path;

    private final String name;

    private final FileType type;

    /**
     * .
     * 
     * @param path
     *            pX
     * @param name
     *            t@C
     * @param type
     *            t@C^Cv
     * @param width
     *            Ot̉
     * @param height
     *            Ot̏c
     * @see FileTypeFactory#create(String,int,int)
     */
    public ChartFile(String path, String name, String type, int width,
            int height) {
        this.path = path;
        this.name = name;
        this.type = FileTypeFactory.create(type, width, height);
    }

    public String getName() {
        return this.name;
    }

    public String getPath() {
        return this.path;
    }

    private FileType getType() {
        return this.type;
    }

    public void saveChart(JFreeChart myChart) {
        String path = this.getPath();
        String createFileName = path + "/" + this.getName();
        Directory directory = DirectoryFactory.create(path);
        directory.make();
        this.getType().saveChart(createFileName, myChart);
    }

}