package com.wikihouse.wildcats0201.jdbcchart.fsutil;

import java.io.File;
import java.util.LinkedList;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * <B>PathSpliterFactory </B>. PathSpliterFactoryłB
 * 
 * @author $Author: wildcats $
 * @version $Revision: 5 $
 */
public final class PathSpliterFactory {

    private PathSpliterFactory() {
    }

    /**
     * 
     * 
     * @param pathName
     *            pX
     * @return PathSpliter
     */
    public static PathSpliter create(String pathName) {
        return create(PathFactory.create(pathName));
    }

    /**
     * 
     * 
     * @param pathName
     *            pX
     * @return PathSpliter
     */
    public static PathSpliter create(Path path) {
        return new PathSpliterImpl(path);
    }

    private static class PathSpliterImpl implements PathSpliter {

        private final Path path;

        public PathSpliterImpl(Path path) {
            this.path = path;
        }

        /**
         * @see com.wikihouse.wildcats0201.jdbcchart.fsutil.PathSpliter#split()
         */
        public Path[] split() {
            String location = path.getPath();
            Pattern pattern = Pattern.compile("[^:]\\" + File.separator);
            Matcher matcher = pattern.matcher(location);
            int cursor = 0;
            List list = new LinkedList();
            while (matcher.find(cursor)) {
                cursor = matcher.end();
                list.add(PathFactory.create(location
                        .substring(0, matcher.end())));
            }
            return (Path[]) list.toArray(new Path[list.size()]);
        }

    }

}
