package com.wikihouse.wildcats0201.jdbcchart.jdbcutil;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;

import com.wikihouse.wildcats0201.jdbcchart.jdbcutil.exception.SQLExceptionWrapper;

/**
 * <B>DriverManagerWrapper </B>. DriverManagerbsONXłB
 * 
 * @see java.sql.DriverManager
 * @author $Author: wildcats $
 * @version $Revision: 5 $
 */
public final class DriverManagerWrapper {

    private DriverManagerWrapper() {
    }

    /**
     * RlNV擾
     * 
     * @param configure
     *            JDBCConnectConfigure
     * @return Connection
     */
    public static Connection getConnection(JDBCConnectConfigure configure) {
        Connection dbConnection = null;
        if (configure.getUser() != null && configure.getPassword() != null) {
            try {
                dbConnection = DriverManager.getConnection(configure.getUrl(),
                        configure.getUser(), configure.getPassword());
            } catch (SQLException e) {
                throw SQLExceptionWrapperFactory.create(e);
            }
        } else if (configure.getUser() == null
                && configure.getPassword() == null) {
            try {
                dbConnection = DriverManager.getConnection(configure.getUrl());
            } catch (SQLException e) {
                throw SQLExceptionWrapperFactory.create(e);
            }
        } else {
            throw new RuntimeException("user password config");
        }
        return dbConnection;
    }

    private static class SQLExceptionWrapperFactory {
        private SQLExceptionWrapperFactory() {
        }

        public static SQLExceptionWrapper create(SQLException e) {
            return new SQLExceptionWrapper(e);
        }
    }

}
