package com.wikihouse.wildcats0201.jdbcchart.reflectionutil;

import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;

/**
 * <B>ReflectionUtil </B>.
 * 
 * @deprecated
 * @author wildcats
 */
public final class ReflectionUtil {

    private ReflectionUtil() {
    }

    public static ClassWrapper forName(String className) {
        Class clazz = null;
        try {
            clazz = Class.forName(className);
        } catch (ClassNotFoundException e) {
            throw new RuntimeException(getExceptionName(e) + "/" + className);
        }
        return new ClassWrapper(clazz);
    }

    public static ConstructorWrapper getConstructor(ClassWrapper clazz,
            ClassArrayWrapper args) {
        Constructor constructor = null;
        try {
            constructor = clazz.get().getConstructor(args.get());
        } catch (SecurityException e) {
            throw new RuntimeException(getExceptionName(e) + "/" + clazz + "/"
                    + args);
        } catch (NoSuchMethodException e) {
            throw new RuntimeException(getExceptionName(e) + "/" + clazz + "/"
                    + args);
        }
        return new ConstructorWrapper(constructor);
    }

    public static Object newInstance(ConstructorWrapper constructor,
            ObjectArrayWrapper objects) {
        Object obj = null;
        try {
            obj = constructor.get().newInstance(objects.get());
        } catch (IllegalArgumentException e) {
            throw new RuntimeException(e);
        } catch (InstantiationException e) {
            throw new RuntimeException(e);
        } catch (IllegalAccessException e) {
            throw new RuntimeException(e);
        } catch (InvocationTargetException e) {
            throw new RuntimeException(e.getTargetException());
        }
        return obj;
    }

    private static String getExceptionName(Exception e) {
        return e.getClass().getName();
    }

}