package com.wikihouse.wildcats0201.jdbcchart.dom4j;

import junit.framework.TestCase;

import com.wikihouse.wildcats0201.jdbcchart.dto.ChartFile;
import com.wikihouse.wildcats0201.jdbcchart.dto.ChartXMLDTO;
import com.wikihouse.wildcats0201.jdbcchart.dto.Item;
import com.wikihouse.wildcats0201.jdbcchart.dto.Label;

/**
 * <B>XMLParseImplTest </B>.
 * 
 * @author $Author: wildcats $
 * @version $Revision: 2 $
 */
public class XMLParseImplTest extends TestCase {

    /*
     * Test method for
     * 'com.wikihouse.wildcats0201.jdbcchart.dom4j.XMLParseImpl.read(String)'
     */
    public void testRead() {
        XMLParser parseImpl = XMLParserFactory.create();
        ChartXMLDTO dto = parseImpl.read("./src/conf/Chart.xml");
        ChartFile file = dto.getFile();
        assertEquals("image", file.getPath());
        assertEquals("xy", file.getName());
        assertEquals(
                "SELECT x_value, y1_value, y2_value, y3_value FROM jdbc_chart",
                dto.getSQL().getText());
        Item[] items = dto.getSeries();
        assertEquals("one", items[0].getName());
        assertEquals("two", items[1].getName());
        assertEquals("three", items[2].getName());
        Label label = dto.getLabel();
        assertEquals("SampleReadByJDBC - XYDataset -", label.getTitle());
        assertEquals("domain", label.getXLabel());
        assertEquals("range", label.getYLabel());
    }

}
